module Tight
  module Engine
    module Defer
      def placeholders
        @placeholders ||= {}
      end

      def defer_element(name, args, opts)
        if settings.respond_to?(:deferred_elements) && settings.deferred_elements.include?(name)
          placeholders[name] = [ name, args, opts ]
          "%{placeholder[:#{name}]}"
        else
          process_element(name, args, opts)
        end
      end

      def process_deferred_elements( text )
        text.to_str.gsub /(\s*)\%\{placeholder\[\:([^\]]+)\]\}/ do
          if deferred = placeholders[$2]
            output = process_element(*deferred)
            if engine.pretty?
              # $/ is magic for CR/LF/CRLF
              indent = $/ + $1
              $1 + output.gsub(/\r|\n|\r\n/, indent) + indent
            else
              output
            end  
          else
            "#{$1}%{placeholder[:#{$2}]}"
          end
        end
      end
    end
  end
end
